//
//  ONSLFontManager.m
//  ONSLauncher
//
//  Created by tmkk on Thu Mar 09 2006.
//  Copyright (c) 2006 tmkk. All rights reserved.
//

#import "ONSLFontManager.h"


@implementation ONSLFontManager

- (id)init
{
	[super init];
	fontArr = [[NSMutableArray alloc] init];
	[self addNewFont:LS(@"OsakaMono") path:@"/System/Library/Fonts/OsakaMono.dfont"];
	[self addNewFont:LS(@"hiraginogo") path:LS(@"hiraginogopath")];
	[self addNewFont:LS(@"hiraginomin") path:LS(@"hiraginominpath")];
	[self addNewFont:LS(@"hiraginomaru") path:LS(@"hiraginomarupath")];
	return self;
}

- (void)addNewFont:(NSString *)name path:(NSString *)path
{
	NSMutableDictionary *dic = [[NSMutableDictionary alloc] init];
	[dic setObject:path forKey:name];
	[fontArr addObject:dic];
	[dic release];
}

- (void)editFont:(NSString *)name newName:(NSString *)newName newPath:(NSString *)newPath
{
	int i;
	for(i=0;i<[fontArr count];i++) {
		if([[fontArr objectAtIndex:i] objectForKey:name]) {
			NSMutableDictionary *dic = [[NSMutableDictionary alloc] init];
			[fontArr removeObjectAtIndex:i];
			[dic setObject:newPath forKey:newName];
			[fontArr insertObject:dic atIndex:i];
			[dic release];
			break;
		}
	}
}

- (void)removeFont:(NSString *)name
{
	int i;
	int n = [fontArr count];
	for(i=0;i<n;i++) {
		if([[fontArr objectAtIndex:i] objectForKey:name]) {
			[fontArr removeObjectAtIndex:i];
			break;
		}
	}
}

- (NSString *)fontNamed:(NSString *)name
{
	int i;
	for(i=0;i<[fontArr count];i++) {
		if([[fontArr objectAtIndex:i] objectForKey:name]) {
			return [[fontArr objectAtIndex:i] objectForKey:name];
		}
	}
	return nil;
}

- (NSString *)fontNameAtIndex:(int)idx
{
	return [[[fontArr objectAtIndex:idx] allKeys] objectAtIndex:0];
}

- (NSArray *)fontNames
{
	NSMutableArray *arr = [[[NSMutableArray alloc] init] autorelease];
	int i;
	for(i=0;i<[fontArr count];i++) {
		[arr addObject:[[[fontArr objectAtIndex:i] allKeys] objectAtIndex:0]];
	}
	return arr;
}

- (int)numberOfFonts
{
	return [fontArr count];
}

- (id)saveFontList
{
	return fontArr;
}

- (void)loadFontList:(id)list
{
	[fontArr release];
	fontArr = [list retain];
}

@end
